/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'minimips.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.minimips.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.minimips.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.minimips.shared.Shared.*;

public final class swc0 extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         swc0.class,
         "swc0",
         false,
         new ArgumentDecls()
             .add("cs", ArgumentMode.IN, COP0.INFO)
             .add("offset", SHORT)
             .add("address", ArgumentMode.OUT, REG.INFO),
         false,
         false,
         false,
         false,
         true,
         32,
         new Shortcuts()
             .addShortcut(new Info_instruction(), "#root")
      );
    }

    @Override
    public IOperation create(Map<String, Object> args) {
      final COP0 cs = (COP0) getArgument("cs", args);
      final Location offset = (Location) getArgument("offset", args);
      final REG address = (REG) getArgument("address", args);

      return new swc0(cs, offset, address);
    }
  }

  private static final class Info_instruction extends InfoAndRule {
    Info_instruction() {
      super(
          instruction.class,
          "swc0",
          true,
          new ArgumentDecls()
              .add("cs", ArgumentMode.IN, COP0.INFO)
              .add("offset", SHORT)
              .add("address", ArgumentMode.OUT, REG.INFO),
          true,
          true,
          false,
          false,
          true,
          32
      );
    }

    @Override
    public IOperation create(Map<String, Object> args) {
      final COP0 cs = (COP0) getArgument("cs", args);
      final Location offset = (Location) getArgument("offset", args);
      final REG address = (REG) getArgument("address", args);

      return new instruction(
        new swc0(
          cs,
          offset,
          address
        )
      );
    }
  }

  public static final IInfo INFO = new Info();

  private final COP0 cs;
  private final Location offset;
  private final REG address;

  public swc0(COP0 cs, Location offset, REG address) {
    assert COP0.INFO.isSupported(cs);
    assert SHORT.equals(offset.getType());
    assert REG.INFO.isSupported(address);

    this.cs = cs;
    this.offset = offset;
    this.address = address;
  }

  @Override
  public String syntax() {
    return String.format("swc0 %s, %d(%s)", cs.syntax(), offset.load().bigIntegerValue(), address.syntax());
  }

  @Override
  public String image() {
    return String.format("111000%s%s%s", address.image(), cs.image(), offset.load().toString());
  }

  @Override
  public void action() {
    try {
    actionBegin();
    M.access(address.access().load().add(Data.signExtend(WORD, offset.load())).shiftRight(Data.valueOf(WORD, 0x2))).store(cs.access().load());
    } finally {
    actionEnd();
    }
  }
}
