/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'vliw.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.vliw.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.vliw.shared.Shared.*;

public final class SLL extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         SLL.class,
         "SLL",
         false,
         new ArgumentDecls()
             .add("rd", ArgumentMode.OUT, R.INFO)
             .add("rt", ArgumentMode.IN, R.INFO)
             .add("sa", INDEX),
         false,
         false,
         false,
         false,
         false,
         0);
    }

    @Override
    public IOperation create(Map<String, Object> args) {
      final R rd = (R) getArgument("rd", args);
      final R rt = (R) getArgument("rt", args);
      final Location sa = (Location) getArgument("sa", args);

      return new SLL(rd, rt, sa);
    }
  }

  public static final IInfo INFO = new Info();

  private final R rd;
  private final R rt;
  private final Location sa;

  public SLL(R rd, R rt, Location sa) {
    assert R.INFO.isSupported(rd);
    assert R.INFO.isSupported(rt);
    assert INDEX.equals(sa.getType());

    this.rd = rd;
    this.rt = rt;
    this.sa = sa;
  }

  @Override
  public String syntax() {
    return String.format("SLL %s, %s, %d", rd.syntax(), rt.syntax(), sa.load().bigIntegerValue());
  }

  @Override
  public String image() {
    return String.format("00000000000%s%s%s000000", rt.image(), rd.image(), sa.load().toString());
  }

  @Override
  public void action() {
    try {
    actionBegin();
    rd.access().store(rt.access().load().shiftLeft(sa.load()));
    } finally {
    actionEnd();
    }
  }
}
