/*
 * Copyright (c) ISPRAS
 * 
 * Institute for System Programming of Russian Academy of Sciences
 * 
 * 25 Alexander Solzhenitsyn st. Moscow 109004 Russia
 * 
 * All rights reserved.
 * 
 * This file was automatically generated by MicroTEST based on the
 * information contained in the 'vliw.nml' specification file.
 * 
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.vliw.op;

import java.util.Map;
import java.math.BigInteger;
import ru.ispras.microtesk.model.api.ArgumentMode;
import ru.ispras.microtesk.model.api.Execution;
import ru.ispras.microtesk.model.api.data.*;
import ru.ispras.microtesk.model.api.memory.*;
import ru.ispras.microtesk.model.api.instruction.*;
import ru.ispras.microtesk.model.vliw.mode.*;
import ru.ispras.microtesk.model.api.memory.Location;

import static ru.ispras.microtesk.model.vliw.shared.Shared.*;

public final class SW extends Operation {
  private static final class Info extends InfoAndRule {
    Info() {
      super(
         SW.class,
         "SW",
         false,
         new ArgumentDecls()
             .add("base", ArgumentMode.OUT, R.INFO)
             .add("rt", ArgumentMode.IN, R.INFO)
             .add("offset", SHORT),
         false,
         false,
         false,
         false,
         true,
         32);
    }

    @Override
    public IOperation create(Map<String, Object> args) {
      final R base = (R) getArgument("base", args);
      final R rt = (R) getArgument("rt", args);
      final Location offset = (Location) getArgument("offset", args);

      return new SW(base, rt, offset);
    }
  }

  public static final IInfo INFO = new Info();

  private final R base;
  private final R rt;
  private final Location offset;

  public SW(R base, R rt, Location offset) {
    assert R.INFO.isSupported(base);
    assert R.INFO.isSupported(rt);
    assert SHORT.equals(offset.getType());

    this.base = base;
    this.rt = rt;
    this.offset = offset;
  }

  @Override
  public String syntax() {
    return String.format("SW %s, %d(%s)", rt.syntax(), offset.load().bigIntegerValue(), base.syntax());
  }

  @Override
  public String image() {
    return String.format("101011%s%s%s", base.image(), rt.image(), offset.load().toString());
  }

  @Override
  public void action() {
    try {
    actionBegin();
    Location.concat(M.access(base.access().load().add(Data.signExtend(WORD, offset.load()))), M.access(base.access().load().add(Data.signExtend(WORD, offset.load())).add(Data.valueOf(WORD, 0x1))), M.access(base.access().load().add(Data.signExtend(WORD, offset.load())).add(Data.valueOf(WORD, 0x2))), M.access(base.access().load().add(Data.signExtend(WORD, offset.load())).add(Data.valueOf(WORD, 0x3)))).store(rt.access().load());
    } finally {
    actionEnd();
    }
  }
}
